
--                            $ADDER.VHD
--
--                          06-29-92 03:49pm
--

type    tdin            is array (1 to NN)              of bit;
type    ch12            is (1,2);
type    ch124           is (1,2,4);
type    ch248           is (2,4,8);
type    tdout           is array (1 to NN+2)            of bit;
--type    tn              is array (1 to n)               of bit;
--type    tk              is array (1 to k)               of bit;
type    tL              is range 1 to 4;
type    tdic            is array (1 to NN+5)            of bit;
type    tcic_sign       is array (0 to 5)               of bit;
type	t4128		is range 4 to 128;


entity $adder
is
generic (
        u_input : bit:='1';
--       
        u_sign  : bit:='1';
--       ਧ
        u_carry : bit:='1';
--       ७
        u_ref   : bit:='1';
--       ८ࠧ
        u_acc   : bit:='1';
--       
        u_out   : bit:='1';
--       뢮
        NN      : t4128;
--      來 ࠭
        zr      : bit;
-- ନ஢ ਧ 
        ovf     : bit
-- ନ஢ ਧ ९
        );

port    (
        A   : in  tdin;
        B   : in  tdin;
        e0  : in  bit;
        dout: out tdout;
        e   : out bit;
        z   : out bit;
        ov  : out bit;
        ovp : out bit
        );
--begin
--  assert();

end $adder;

architecture add of $adder is 
begin

ADDER:
block
        signal  dic                     : tdic;
        signal  dic_sign,dic_carry,
                ic_sign,ic_carry        : tcic_sign;
        signal  a_ic,b_ic               : tdin;
        signal  data_ic1,data_ic2,
                data_ic3                : tdout;


  component     uin
                generic (
                        NN      : t4128
                        );
                port    (
                        da      : in tdin;
                        db      : in tdin;
                        e0      : in bit;
                        te      : in tdic;
                        dout_a  : out tdin;
                        dout_b  : out tdin
                        );
  end component;

  component     usn
                generic (
                        NN      : t4128
                        );
                port    (
                        da      : in tdin;
                        db      : in tdin;
                        te      : in tcic_sign;
                        ts      : out tcic_sign
                        );
  end component;


  component     $uad
                generic (

                        NN      : t4128;
                        n       : ch124;
                        k2      : ch248;
                        k3      : ch248;
                        k4      : ch248;
                        l       : tL)
                        ;

                port    (
                        A   : in  tdin;
                        B   : in  tdin;
                        e0  : in  bit;
                        dout: out tdout;
                        e   : out bit;
                        z   : out bit;
                        ov  : out bit;
                        ovp : out bit
                        );

  end component;

  component     ucr
                generic (
                        NN      : t4128
                        );
                port    (
                        da      : in tdin;
                        db      : in tdin;
                        te      : in tcic_sign;
                        ts      : out tcic_sign
                        );
  end component;

  component     urf
                generic (
                        NN      : t4128
                        );
                port    (
                        dc      : in  tdout;
                        db      : out tdout
                        );
  end component;

  component     uac
                generic (
                        NN      : t4128
                        );
                port    (
                        dc      : in  tdout;
                        te      : out tdic;
                        dout    : out tdout
                        );
  end component;

  component     uot
                generic (
                        NN      : t4128
                        );
                port    (
                        din     : in  tdout;
                        te      : in  tcic_sign;
                        ts      : in  tcic_sign;
			ov	: out bit;
			ovp	: out bit;
			z	: out bit;
			e	: out bit;
                        dout    : out tdout
                        );
  end component;

  begin

  if(u_input='1') generate
    d1: uin     generic map(NN)
                port    map(A,B,e0,dic,a_ic,b_ic);
  end generate;
  if(u_input='0') generate
    for i in 1 to NN generate
      a_ic(i)<=A(i);
      b_ic(i)<=B(i);
    end generate;
  end generate;

  d3:   $uad    generic map (NN,open,open,open,open,open)
                port    map (a_ic,b_ic,e0,data_ic1,dic_carry(0),dic_carry(1),
                             dic_sign(0),dic_sign(1));

  if(u_sign='1') generate
    d2: usn     generic map(NN)
                port    map(A,B,dic_sign,ic_sign);
  end generate;
  if(u_sign='0') generate
    for i in 1 to 5 generate
      ic_sign(i)<=dic_sign(i);
    end generate;
  end generate;

  if(u_carry='1') generate
    d4: ucr     generic map(NN)
                port    map(A,B,dic_carry,ic_carry);
  end generate;

  if(u_ref='1') generate
    d5: urf     generic map(NN)
                port    map(data_ic1,data_ic2);
  end generate;
  if(u_ref='0') generate
    for i in 1 to NN+2 generate
      data_ic2(i)<=data_ic1(i);
    end generate;
  end generate;

  if(u_acc='1') generate
    d6: uac     generic map(NN)
                port    map(data_ic2,dic,data_ic3);
  end generate;
  if(u_acc='0') generate
    for i in 1 to NN+2 generate
      data_ic3(i)<=data_ic2(i);
    end generate;
  end generate;

  if(u_out='1') generate
    d7: uot     generic map(NN)
                port    map(data_ic3,ic_carry,ic_sign,ov,ovp,z,e,dout);
  end generate;
  if(u_out='0') generate
    for i in 1 to NN+2 generate
      dout(i)<=data_ic3(i);
    end generate;
    ov <= dic_carry(0);
    ovp<= dic_carry(1);
    z  <= dic_sign (0);
    e  <= dic_sign (1);
  end generate;

  end block;
end add;