entity Var15 is
	port (C,X11,X12,X13,X14,X21,X22,X23,X24,A1,A2: in bit; Y1,NY1,Y2,NY2: out bit);
end Var15;
entity NE is
        port  (X:in bit; Y:out bit);
end NE;
architecture STRUCT of NE is
   begin
       Y<= not(X);	
   end;
entity INE is
        port  (X1,X2,X3,X4:in bit; Y:out bit);
end INE;
architecture STRUCT of INE is
   begin
       Y<= not(X1 and X2 and X3 and X4);	
   end;     
entity MUX4 is
        port  (C,X1,X2,X3,X4,Z1,Z2,Z3,Z4:in bit; Y,NY:out bit);
end MUX4;
architecture STRUCT of MUX4 is
        component NE
        port  (X:in bit; Y:out bit);
        end component;
        component INE
        port  (X1,X2,X3,X4:in bit; Y:out bit);
        end component;
        signal S1,S2,S3,S4,S5: bit;
   begin
	U1: INE port map(C,X1,Z1,Z3,S1);
	U2: INE port map(C,X2,Z1,Z4,S2);
	U3: INE port map(C,X2,Z2,Z3,S3);
	U4: INE port map(C,X2,Z2,Z4,S4);
	U5: INE port map(S1,S2,S3,S4,S5);
	U6: NE port map (S5,NY);
        Y<=S5;
   end; 
architecture BEHAVIOR of Var15 is
   begin
      process
         begin             
         if  (C='1')       
             then Y1<='0'; NY1<='1'; Y2<='0'; NY2<='1'; 
             else case (A1 & A2) is
			when "00" => Y1<=X11; NY1<=not(X11); Y2<=X21; NY2<=not(X21);
			when "01" => Y1<=X12; NY1<=not(X12); Y2<=X22; NY2<=not(X22);
			when "10" => Y1<=X13; NY1<=not(X13); Y2<=X23; NY2<=not(X23);
			when "11" => Y1<=X14; NY1<=not(X14); Y2<=X24; NY2<=not(X24);
                  end case; 
         end if;
         wait  on  C,X11,X12,X13,X14,X21,X22,X23,X24,A1,A2;
      end process;
   end ;
architecture STRUCT of Var15 is
        component NE
        port  (X:in bit; Y:out bit);
        end component;
        component MUX4
        port  (C,X1,X2,X3,X4,Z1,Z2,Z3,Z4:in bit; Y,NY:out bit);
        end component;
        signal S1,S2,S3,S4,SC: bit;               
 begin                     
   U1:NE  port  map  (C,SC);    
   U2:NE  port  map (A1,S1);     
   U3:NE  port  map (A2,S2);     
   U4:NE  port  map (S1,S3);   
   U5:NE  port  map (S2,S4);  
   M1:MUX4 port map (SC,X11,X12,X13,X14,S1,S2,S3,S4,Y1,NY1) ;
   M2:MUX4 port map (SC,X21,X22,X23,X24,S1,S2,S3,S4,Y2,NY2) ;
 end;
